import { readFileSync } from 'fs';

export type ServerConfig = {
  port: number;
  origin: string[];
};

export type MongoConfig = {
  uri: string;
  dbName: string;
};

export class Config {
  server: ServerConfig;
  mongo: MongoConfig;

  constructor(configFile: string) {
    const config = JSON.parse(readFileSync(configFile).toString()) as Config;
    if (
      config.mongo.dbName === undefined ||
      config.mongo.uri === undefined ||
      config.server.origin === undefined ||
      config.server.port === undefined
    ) {
      console.log('Error in Config File');
      process.exit(1);
    }
    this.server = config.server;
    this.mongo = config.mongo;
  }
}
