import { checkSchema } from 'express-validator';
import { CardRarity } from '@core';

export const CreateCardSchema = () =>
  checkSchema({
    name: {
      isString: true,
    },
    rarity: {
      isIn: {
        options: [Object.values(CardRarity)],
      },
    },
    thumbnail: {
      isString: true,
    },
    model: {
      isString: true,
    },
  });

export const ReadCardSchema = () =>
  checkSchema({
    uuid: {
      isUUID: {
        options: 4,
      },
    },
  });
