import { EntityInfo } from './entity';

export enum CardRarity {
  COMMON = 'COMMON',
  RARE = 'RARE',
  EPIC = 'EPIC',
  LEGENDARY = 'LEGENDARY',
}

export type CombatStats = {
  baseAtk: number;
  baseDef: number;
  baseCrit: number;
  multAtk: number;
  multDef: number;
  multCrit: number;
};

export type CardInfo = {
  uuid: string;
  name: string;
  rarity: keyof typeof CardRarity;
  stats: CombatStats;
  thumbnail: string;
  model: string;
};

export type CreateCardBody = {
  name: string;
  rarity: keyof typeof CardRarity;
  stats: CombatStats;
  thumbnail: string;
  model: string;
};

export type Card = CardInfo & EntityInfo;

export type CardCtor = Partial<Card>;

export type UpdateCardBody = Partial<Omit<CardInfo, 'uuid'>>;
