export function save(key: string, data: unknown) {
  if (data) {
    localStorage.setItem(key, JSON.stringify(data));
  } else {
    remove(key);
  }
}

export function remove(key: string) {
  localStorage.removeItem(key);
}

export function read<T>(key: string) {
  const data = localStorage.getItem(key);
  if (data) {
    return JSON.parse(data) as T;
  }
  return null;
}
